(function() {
    // Base64 encode / decode
    // http://www.webtoolkit.info/
    if (window.XBase64 == null) {
        window.XBase64 = {
            // private property
            _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
            // public method for encoding
            encode : function (input) {
                var output = "";
                var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
                var i = 0;
                input = window.XBase64._utf8_encode(input);
                while (i < input.length) {
                    chr1 = input.charCodeAt(i++);
                    chr2 = input.charCodeAt(i++);
                    chr3 = input.charCodeAt(i++);
                    enc1 = chr1 >> 2;
                    enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
                    enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
                    enc4 = chr3 & 63;
                    if (isNaN(chr2)) {
                        enc3 = enc4 = 64;
                    } else if (isNaN(chr3)) {
                        enc4 = 64;
                    }
                    output = output +
                    this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
                    this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
                }
                return output;
            },
            // public method for decoding
            decode : function (input) {
                var output = "";
                var chr1, chr2, chr3;
                var enc1, enc2, enc3, enc4;
                var i = 0;
                input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
                while (i < input.length) {
                    enc1 = this._keyStr.indexOf(input.charAt(i++));
                    enc2 = this._keyStr.indexOf(input.charAt(i++));
                    enc3 = this._keyStr.indexOf(input.charAt(i++));
                    enc4 = this._keyStr.indexOf(input.charAt(i++));
                    chr1 = (enc1 << 2) | (enc2 >> 4);
                    chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
                    chr3 = ((enc3 & 3) << 6) | enc4;
                    output = output + String.fromCharCode(chr1);
                    if (enc3 != 64) {
                        output = output + String.fromCharCode(chr2);
                    }
                    if (enc4 != 64) {
                        output = output + String.fromCharCode(chr3);
                    }
                }
                output = window.XBase64._utf8_decode(output);
                return output;
            },
            // private method for UTF-8 encoding
            _utf8_encode : function (string) {
                string = string.replace(/\r\n/g,"\n");
                var utftext = "";
                for (var n = 0; n < string.length; n++) {
                    var c = string.charCodeAt(n);
                    if (c < 128) {
                        utftext += String.fromCharCode(c);
                    }
                    else if((c > 127) && (c < 2048)) {
                        utftext += String.fromCharCode((c >> 6) | 192);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                    else {
                        utftext += String.fromCharCode((c >> 12) | 224);
                        utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                        utftext += String.fromCharCode((c & 63) | 128);
                    }
                }
                return utftext;
            },
            // private method for UTF-8 decoding
            _utf8_decode : function (utftext) {
                var string = "";
                var i = 0;
                var c = c1 = c2 = 0;
                while ( i < utftext.length ) {
                    c = utftext.charCodeAt(i);
                    if (c < 128) {
                        string += String.fromCharCode(c);
                        i++;
                    }
                    else if((c > 191) && (c < 224)) {
                        c2 = utftext.charCodeAt(i+1);
                        string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                        i += 2;
                    }
                    else {
                        c2 = utftext.charCodeAt(i+1);
                        c3 = utftext.charCodeAt(i+2);
                        string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                        i += 3;
                    }
                }
                return string;
            },
            // object To Base64 data
            encodeObject : function(data) {
                return new Promise((resolve, reject) => {
                    if (data instanceof Blob) {
                        // Handle Blob
                        const reader = new FileReader();
                        reader.onload = () => resolve(reader.result.split(',')[1]);
                        reader.onerror = reject;
                        reader.readAsDataURL(data);
                    } else if (data instanceof ArrayBuffer || ArrayBuffer.isView(data)) {
                        // Handle ArrayBuffer, TypedArray, and DataView
                        const binary = '';
                        const bytes = new Uint8Array(data instanceof ArrayBuffer ? data : data.buffer);
                        for (let i = 0; i < bytes.byteLength; i++) {
                            binary += String.fromCharCode(bytes[i]);
                        }
                        resolve(window.XBase64.encode(binary));
                    } else if (data instanceof FormData) {
                        // Handle FormData
                        const formEntries = Array.from(data.entries());
                        const formObject = formEntries.reduce((acc, [key, value]) => {
                            acc[key] = value instanceof Blob ? 'File: ' + value.name : value;
                            return acc;
                        }, {});
                        resolve(window.XBase64.encode(unescape(encodeURIComponent(JSON.stringify(formObject)))));
                    } else if (data instanceof URLSearchParams) {
                        // Handle URLSearchParams
                        resolve(window.XBase64.encode(unescape(encodeURIComponent(data.toString()))));
                    } else if (typeof data === 'string') {
                        // Handle string
                        resolve(window.XBase64.encode(unescape(encodeURIComponent(data))));
                    } else if (typeof data === 'object') {
                        // Handle plain object
                        resolve(window.XBase64.encode(unescape(encodeURIComponent(JSON.stringify(data)))));
                    } else {
                        // Handle other types
                        resolve(window.XBase64.encode(unescape(encodeURIComponent(String(data)))));
                    }
                });
            }
        };
    }
})();

(function() {
    if (window.requestIdleCallback == null) {
        // 模拟 requestIdleCallback 函数
        function mockRequestIdleCallback(callback, options = {}) {
            const timeout = (options.timeout == null || options.timeout == undefined) ? 32 : options.timeout // 默认超时时间，可根据需要调整
            const maxDeadline = Date.now() + timeout

            // 创建一个模拟的 IdleDeadline 对象
            const mockDeadline = {
                didTimeout: false,
                timeRemaining() {
                    const currentTime = Date.now()
                    if (currentTime >= maxDeadline) {
                        this.didTimeout = true
                        return 0
                    }
                    return Math.max(0, maxDeadline - currentTime)
                },
            }

            // 使用 setTimeout 模拟空闲回调
            return setTimeout(() => {
                callback(mockDeadline)
            }, 0)
        }

        // 取消逻辑可以简单地忽略，因为setTimeout已经触发
        // 或者尝试清除定时器，但可能已执行，故实际效果有限
        function mockCancelIdleCallback(id) {
            clearTimeout(id)
        }

        window.requestIdleCallback = window.requestIdleCallback || mockRequestIdleCallback
        window.cancelIdleCallback = window.cancelIdleCallback || function(id) { clearTimeout(id) }
    }
})();

(function() {
  if (window.PositionObserver == null) {
      /**
       * 比较2个位置数据是否一致
       * @param {IPosition} p1 位置1
       * @param {IPosition} p2 位置2
       * @returns {boolean}
       */
      function isSamePosition(p1, p2) {
          if (p1.bottom !== p2.bottom) return false
          if (p1.top !== p2.top) return false
          if (p1.left !== p2.left) return false
          if (p1.right !== p2.right) return false
          if (p1.width !== p2.width) return false
          if (p1.height !== p2.height) return false
          return true
      }

      /**
       * @typedef IThrottleOptions
       * @property {boolean} leading 是否首次调用立即执行
       * @property {boolean} trailing 是否在结束时调用
       *
       */
      /**
       * 函数节流
       * @param {Function} func 需要进行节流的函数
       * @param {number} wait 周期时长
       * @param {Partial<IThrottleOptions>=} options 可选参数
       * @returns {typeof func}
       */
      function throttle(func, wait, options) {
        var timeout, context, args, result;

        // 上一次执行回调的时间戳
        var previous = 0;

        // 无传入参数时，初始化 options 为空对象
        if (!options) options = {};

        var later = function() {
          // 当设置 { leading: false } 时
          // 每次触发回调函数后设置 previous 为 0
          // 不然为当前时间
          previous = options.leading === false ? 0 : Date.now();

          // 防止内存泄漏，置为 null 便于后面根据 !timeout 设置新的 timeout
          timeout = null;

          // 执行函数
          result = func.apply(context, args);
          if (!timeout) context = args = null;
        };

        // 每次触发事件回调都执行这个函数
        // 函数内判断是否执行 func
        // func 才是我们业务层代码想要执行的函数
        var throttled = function() {

          // 记录当前时间
          var now = Date.now();

          // 第一次执行时（此时 previous 为 0，之后为上一次时间戳）
          // 并且设置了 { leading: false }（表示第一次回调不执行）
          // 此时设置 previous 为当前值，表示刚执行过，本次就不执行了
          if (!previous && options.leading === false) previous = now;

          // 距离下次触发 func 还需要等待的时间
          var remaining = wait - (now - previous);
          context = this;
          args = arguments;

          // 要么是到了间隔时间了，随即触发方法（remaining <= 0）
          // 要么是没有传入 {leading: false}，且第一次触发回调，即立即触发
          // 此时 previous 为 0，wait - (now - previous) 也满足 <= 0
          // 之后便会把 previous 值迅速置为 now
          if (remaining <= 0 || remaining > wait) {
            if (timeout) {
              clearTimeout(timeout);

              // clearTimeout(timeout) 并不会把 timeout 设为 null
              // 手动设置，便于后续判断
              timeout = null;
            }

            // 设置 previous 为当前时间
            previous = now;

            // 执行 func 函数
            result = func.apply(context, args);
            if (!timeout) context = args = null;
          } else if (!timeout && options.trailing !== false) {
            // 最后一次需要触发的情况
            // 如果已经存在一个定时器，则不会进入该 if 分支
            // 如果 {trailing: false}，即最后一次不需要触发了，也不会进入这个分支
            // 间隔 remaining milliseconds 后触发 later 方法
            timeout = setTimeout(later, remaining);
          }
          return result;
        };

        // 手动取消
        throttled.cancel = function() {
          clearTimeout(timeout);
          previous = 0;
          timeout = context = args = null;
        };

        // 执行 _.throttle 返回 throttled 函数
        return throttled;
      }

      class PositionObserver {
          /** @type {IntersectionObserver} */
          _intersectionObserver = null;
          /** @type {number[]} */
          _runner = [];
          /** @type {WeakMap<object, IRecord>} */
          _records = new WeakMap();
          /**
          * 更新记录
          * @param {HTMLElement} targetEl 观测DOM
          * @param {Partial<IRecord>} partialData 需要更新的数据
          */
          _updateRecord = (targetEl, partialData) => {
              const data = this._records.get(targetEl)
              const updatedData = Object.assign({}, data, partialData)
              this._records.set(targetEl, updatedData)
          }

          constructor() {
              this._intersectionObserver = new IntersectionObserver((entries) => {
                  entries.forEach((entry) => {
                      const targetEl = entry.target
                      const isIntersecting = typeof entry.isIntersecting === 'boolean' ? entry.isIntersecting : entry.intersectionRatio > 0
                      if (isIntersecting) {
                          this._startObserve(targetEl)
                      } else {
                          this._stopObserve(targetEl)
                      }
                  })
              })
          }

          /**
          * 开启元素位置实时获取（idle）
          * @param {HTMLElement} targetEl 待观测的DOM元素
          * @returns
          */
          _startObserve = (targetEl) => {
              const record = this._records.get(targetEl)
              if (!record) return
              if (record.cancelIdleId) return
              const { callback } = record
              const computeDOMPosition = throttle(() => {
                  const rect = targetEl.getBoundingClientRect()
                  const { top, right, bottom, left, width, height } = rect
                  const record = this._records.get(targetEl)
                  const prev = record ? record.position : undefined
                  const position = { top, right, bottom, left, width, height }
                  if (!prev || !isSamePosition(prev, position)) {
                      callback(targetEl, position, this)
                  }
                  this._updateRecord(targetEl, { position })
              }, 30, { leading: true, trailing: true });

              /**
               * 在页面空闲时间计算目标元素的位置信息
               * @type IdleRequestCallback
               */
              const computeDOMPositionWhenIdle = (deadline) => {
                  if (deadline.didTimeout) return
                  while (deadline.timeRemaining() > 0) {
                      computeDOMPosition()
                  }
                  const cancelIdleId = requestIdleCallback(computeDOMPositionWhenIdle)
                  this._updateRecord(targetEl, { cancelIdleId })
              }

              const cancelIdleId = requestIdleCallback(computeDOMPositionWhenIdle)
              this._updateRecord(targetEl, { cancelIdleId })
              this._runner.push(cancelIdleId)
          }

          /**
          * 停止元素位置实时获取(idle)
          * @param {HTMLElement} targetEl 待观测的DOM元素
          * @returns
          */
          _stopObserve = (targetEl) => {
              const record = this._records.get(targetEl)
              if (!record) return
              const { cancelIdleId } = record
              if (!cancelIdleId) return
              cancelIdleCallback(cancelIdleId)
              this._runner = this._runner.filter(id => id !== cancelIdleId)
              this._updateRecord(targetEl, { cancelIdleId: 0 })
          }

          /**
          * 开始观察元素的位置变化
          * @param {HTMLElement|string} target 需要观察的DOM元素
          * @param {IObserveCallback} callback 对象位置变化时的回调函数
          */
          observe(target, callback) {
              /** @type HTMLElement */
              const targetEl = target instanceof HTMLElement ? target : document.querySelector(target)
              if (!targetEl) {
                  console.error(new Error('观察元素无法找到'))
                  return
              }
              if (this._records.has(targetEl)) {
                  console.error(new Error('元素已经被观察，请不要重复观测'))
                  return
              } else {
                  // 初始化位置信息
                  const rect = targetEl.getBoundingClientRect()
                  const { top, right, bottom, left, width, height } = rect
                  const position = { top, right, bottom, left, width, height }
                  callback(targetEl, position, this)
                  this._updateRecord(targetEl, { position, callback })
              }

              this._intersectionObserver.observe(targetEl)
          }

          unobserve(target) {
              /** @type {HTMLElement} */
              const targetEl = target instanceof HTMLElement ? target : document.querySelector(target)
              if (!targetEl) return
              const record = this._records.get(targetEl)
              if (!record) return
              if (record.cancelIdleId) {
                  cancelIdleCallback(record.cancelIdleId)
                  this._runner = this._runner.filter(id => id !== record.cancelIdleId)
              }
              this._records.delete(targetEl)
              this._intersectionObserver.unobserve(targetEl)
          }

          disconnect() {
              this._runner.forEach(cancelIdleId => cancelIdleCallback(cancelIdleId))
              this._runner = []
              this._records = new WeakMap()
              this._intersectionObserver.disconnect()
          }
      }

      window.PositionObserver = PositionObserver;
  }
})();
